Subject: Document change in format of raw diff output format

From: Greg Hurrell <[email-masked]>
Date: Fri, 23 Nov 2018 10:09:07 +0100

Jeff King wrote:

> On Thu, Nov 22, 2018 at 11:58:36AM +0100, Greg Hurrell wrote:
> 
> > diff --git a/Documentation/diff-format.txt b/Documentation/diff-format.txt
> > index 706916c94c..33776459d0 100644
> > --- a/Documentation/diff-format.txt
> > +++ b/Documentation/diff-format.txt
> > @@ -26,12 +26,12 @@ line per changed file.
> >  An output line is formatted this way:
> > 
> >  ------------------------------------------------
> > -in-place edit  :100644 100644 bcd1234... 0123456... M file0
> > -copy-edit      :100644 100644 abcd123... 1234567... C68 file1 file2
> > -rename-edit    :100644 100644 abcd123... 1234567... R86 file1 file3
> > -create         :000000 100644 0000000... 1234567... A file4
> > -delete         :100644 000000 1234567... 0000000... D file5
> > -unmerged       :000000 000000 0000000... 0000000... U file6
> > +in-place edit  :100644 100644 bcd123456 012345678 M file0
> > +copy-edit      :100644 100644 abcd12345 123456789 C68 file1 file2
> > +rename-edit    :100644 100644 abcd12345 123456789 R86 file1 file3
> > +create         :000000 100644 000000000 123456789 A file4
> > +delete         :100644 000000 123456789 000000000 D file5
> > +unmerged       :000000 000000 000000000 000000000 U file6
> >  ------------------------------------------------
> 
> Yeah, this looks like an improvement.
> 
> I think in general that we'd continue to show 7 characters now, just
> without the extra dots (though it's auto-scaled based on the number of
> objects in the repo these days, so it's not even really a constant).

That's funny. I looked at the output on (what I thought was) a small
repo and it was showing me 9-character abbreviated hashes. I guess I
just got lucky. Tested on a basically empty repo and 7 does look to be
the default.

> PS As you noticed, "git log" we don't promise that git-log output will
>    never change between versions. For machine-consumption you probably
>    want to use plumbing like "git rev-list | git diff-tree --stdin",
>    which produces unabbreviated hashes.

Thanks for the tip. My mistake was thinking that the `--raw` made the
`git log` output somehow more plumbing-ish, but I've gone ahead and
switched to using git-rev-list plus git-diff-tree instead.

Anyway, patch follows.